/* Exemple simple d'utilisation d'une carte son sous Linux :
   Il s'agit de jouer une minute de silence en qualite CD... */

#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <sys/soundcard.h>

#define DEVICE "/dev/dsp"
#define FORMAT AFMT_S16_LE
#define CHANNELS 2
#define SPEED 44100

#define LENGTH (60 * SPEED)

int
main (void)
{
  int i;

  int audio;  /* file descriptor */

  int format, channels, speed;

  /* open the sound device */

  audio = open (DEVICE, O_WRONLY);
  if (audio == -1) { exit (EXIT_FAILURE); }

  /* set up the sound card */

  format = FORMAT;  /* sample type */
  ioctl (audio, SOUND_PCM_SETFMT, &format);
  if (format != FORMAT) { close (audio); exit (EXIT_FAILURE); }

  channels = CHANNELS;  /* number of channels */
  ioctl (audio, SNDCTL_DSP_CHANNELS, &channels);
  if (channels != CHANNELS) { close (audio); exit (EXIT_FAILURE); }

  speed = SPEED;  /* sampling rate */
  ioctl (audio, SNDCTL_DSP_SPEED, &speed);
  if (speed != SPEED) { close (audio); exit (EXIT_FAILURE); }

  /* play the audio samples */

  for (i=0; i<LENGTH; i++)
    {
      short s[CHANNELS] = { 0, 0 };  /* 16-bit, signed, little-endian integers */

      write (audio, s, CHANNELS*sizeof(short));
    }

  /* close the sound device */

  close (audio);

  exit (EXIT_SUCCESS);
}

/* End Of File */
